(module reify mzscheme
  (require (lib "match.ss"))
  
  (provide current-reify 
           reify/compile
           reify/share)
  
  
  (define (reify/compile store v)
    (match v
      [`null '()]
      [`(quote ,(? symbol? s)) s]
      [(? symbol?) 
       (let ([ent (assq v store)])
         (unless ent (error 'reify "free variable ~s" v))
         (match ent 
           [`(,var (cons ,va ,vd))
            (kons (reify/compile store va) (reify/compile store vd))]))]
      [else v]))
  
  (define (kons kar kdr)
    (cond
      [(or (null? kdr) (pair? kdr)) `(,kar ,@kdr)]
      [else `(,kar dot ,kdr)]))
  
  (define (reify/share store v)
    (let loop ([v v])
      (match v
        [`null '()]
        [`(quote ,(? symbol? s)) s]
        [(? symbol?)
         (let ([ent (assq v store)])
           (unless ent (error 'reify "free variable ~s" v))
           (match ent 
             [`(,var (cons 'quote ,vd))
              (let ([ent (assq vd store)])
                (match ent
                  [`(,var (cons ,va null))
                   va]
                  [else (kons (loop 'quote) (loop vd))]))]
             [`(,var (cons ,va ,vd))
              (kons (loop va) (loop vd))]))]
        [else v])))
  
  (define current-reify (make-parameter reify/compile)))
