(module test-proof-coloring mzscheme
  (require "show-r5-examples.scm"
           (planet "gui.ss" ("robby" "redex.plt" 2 4)))
  
  ;; the term below contains some red that gets turned back
  ;; white after future reductions appear, but only in
  ;; the single stepping mode (with cutoff 1, as below)

  ;; the begin is there just to have an extra step
  ;; at the beginning
  
  (reduction-steps-cutoff 1)
  
  (r5rs-show '(store
               ((c:1 (lambda (x) x))
                (x c:1)
                (c:2 (lambda (x) x))
                (y c:2))
               (dw
                ()
                (begin
                  (if (#%eqv? c:1 c:2)
                      (#%* 2 2)
                      (#%+ (#%+ 1 1) 2))))))
  
  ;; this is the term from the paper, in part ii, on eq?
  #;
  (r5rs-show '(store
               ()
               (dw
                ()
                (define f (lambda (x) x))
                (define g (lambda (y) y))
                (#%eqv? f g))))
  
  ;; and it reduces to this one, eventually (as shown in the figure)
  #;
  (r5rs-show '(store
               ((c:1 (lambda (x) x))
                (f c:1)
                (c:2 (lambda (y) y))
                (g c:2))
               (dw () (#%eqv? c:1 c:2)))))